---
title: Manifest
weight: 7
---

# Manifest

This doc contains all Tempo options and their defaults. It is likely quite overwhelming and if you are just getting 
started it is recommend to check [Tempo examples](https://github.com/grafana/tempo/tree/main/example/docker-compose) 
and other [configuration documentation](..). Most installations will require only setting 10 to 20 of these options.

It was generated by running Tempo with a minimal configuration and accessing the `/status/config` endpoint:
```
go run ./cmd/tempo --storage.trace.backend=local --storage.trace.local.path=/tmp/tempo/traces --storage.trace.wal.path=/tmp/tempo/wal
```

## Complete Configuration

> **Note**: This manifest was generated on 2021-10-27.

```yaml
target: all
http_api_prefix: ""
server:
  http_listen_network: tcp
  http_listen_address: ""
  http_listen_port: 80
  http_listen_conn_limit: 0
  grpc_listen_network: tcp
  grpc_listen_address: ""
  grpc_listen_port: 9095
  grpc_listen_conn_limit: 0
  http_tls_config:
    cert_file: ""
    key_file: ""
    client_auth_type: ""
    client_ca_file: ""
  grpc_tls_config:
    cert_file: ""
    key_file: ""
    client_auth_type: ""
    client_ca_file: ""
  register_instrumentation: true
  graceful_shutdown_timeout: 30s
  http_server_read_timeout: 30s
  http_server_write_timeout: 30s
  http_server_idle_timeout: 2m0s
  grpc_server_max_recv_msg_size: 4194304
  grpc_server_max_send_msg_size: 4194304
  grpc_server_max_concurrent_streams: 100
  grpc_server_max_connection_idle: 2562047h47m16.854775807s
  grpc_server_max_connection_age: 2562047h47m16.854775807s
  grpc_server_max_connection_age_grace: 2562047h47m16.854775807s
  grpc_server_keepalive_time: 2h0m0s
  grpc_server_keepalive_timeout: 20s
  grpc_server_min_time_between_pings: 10s
  grpc_server_ping_without_stream_allowed: true
  log_format: logfmt
  log_level: info
  log_source_ips_enabled: false
  log_source_ips_header: ""
  log_source_ips_regex: ""
  http_path_prefix: ""
distributor:
  ring:
    kvstore:
      store: memberlist
      prefix: collectors/
      consul:
        host: localhost:8500
        acl_token: ""
        http_client_timeout: 20s
        consistent_reads: false
        watch_rate_limit: 1
        watch_burst_size: 1
      etcd:
        endpoints: []
        dial_timeout: 10s
        max_retries: 10
        tls_enabled: false
        tls_cert_path: ""
        tls_key_path: ""
        tls_ca_path: ""
        tls_server_name: ""
        tls_insecure_skip_verify: false
        username: ""
        password: ""
      multi:
        primary: ""
        secondary: ""
        mirror_enabled: false
        mirror_timeout: 2s
    heartbeat_period: 5s
    heartbeat_timeout: 5m0s
    instance_id: hostname
    instance_interface_names:
      - eth0
      - en0
    instance_port: 0
    instance_addr: ""
  receivers: {}
  override_ring_key: distributor
  log_received_traces: false
  extend_writes: true
  search_tags_deny_list: []
ingester_client:
  pool_config:
    checkinterval: 15s
    healthcheckenabled: true
    healthchecktimeout: 1s
  remote_timeout: 5s
  grpc_client_config:
    max_recv_msg_size: 104857600
    max_send_msg_size: 16777216
    grpc_compression: snappy
    rate_limit: 0
    rate_limit_burst: 0
    backoff_on_ratelimits: false
    backoff_config:
      min_period: 100ms
      max_period: 10s
      max_retries: 10
    tls_enabled: false
    tls_cert_path: ""
    tls_key_path: ""
    tls_ca_path: ""
    tls_server_name: ""
    tls_insecure_skip_verify: false
querier:
  query_timeout: 10s
  search_query_timeout: 30s
  search_external_endpoints: []
  max_concurrent_queries: 5
  frontend_worker:
    frontend_address: 127.0.0.1:9095
    scheduler_address: ""
    dns_lookup_duration: 10s
    parallelism: 2
    match_max_concurrent: true
    id: ""
    grpc_client_config:
      max_recv_msg_size: 104857600
      max_send_msg_size: 16777216
      grpc_compression: gzip
      rate_limit: 0
      rate_limit_burst: 0
      backoff_on_ratelimits: false
      backoff_config:
        min_period: 100ms
        max_period: 1s
        max_retries: 5
      tls_enabled: false
      tls_cert_path: ""
      tls_key_path: ""
      tls_ca_path: ""
      tls_server_name: ""
      tls_insecure_skip_verify: false
query_frontend:
  log_queries_longer_than: 0s
  max_body_size: 0
  query_stats_enabled: false
  max_outstanding_per_tenant: 100
  querier_forget_delay: 0s
  scheduler_address: ""
  scheduler_dns_lookup_period: 0s
  scheduler_worker_concurrency: 0
  grpc_client_config:
    max_recv_msg_size: 0
    max_send_msg_size: 0
    grpc_compression: ""
    rate_limit: 0
    rate_limit_burst: 0
    backoff_on_ratelimits: false
    backoff_config:
      min_period: 0s
      max_period: 0s
      max_retries: 0
    tls_enabled: false
    tls_cert_path: ""
    tls_key_path: ""
    tls_ca_path: ""
    tls_server_name: ""
    tls_insecure_skip_verify: false
  instance_interface_names: []
  address: ""
  port: 0
  downstream_url: ""
  max_retries: 2
  query_shards: 20
  search:
    concurrent_jobs: 50
    target_bytes_per_job: 10485760
    default_result_limit: 20
    max_result_limit: 0
    max_duration: 1h1m0s
    query_backend_after: 15m0s
    query_ingesters_until: 1h0m0s
compactor:
  ring:
    kvstore:
      store: ""
      prefix: collectors/
      consul:
        host: localhost:8500
        acl_token: ""
        http_client_timeout: 20s
        consistent_reads: false
        watch_rate_limit: 1
        watch_burst_size: 1
      etcd:
        endpoints: []
        dial_timeout: 10s
        max_retries: 10
        tls_enabled: false
        tls_cert_path: ""
        tls_key_path: ""
        tls_ca_path: ""
        tls_server_name: ""
        tls_insecure_skip_verify: false
        username: ""
        password: ""
      multi:
        primary: ""
        secondary: ""
        mirror_enabled: false
        mirror_timeout: 2s
    heartbeat_period: 5s
    heartbeat_timeout: 1m0s
    wait_stability_min_duration: 1m0s
    wait_stability_max_duration: 5m0s
    instance_id: hostname
    instance_interface_names:
      - eth0
      - en0
    instance_port: 0
    instance_addr: ""
    wait_active_instance_timeout: 10m0s
  compaction:
    chunk_size_bytes: 5242880
    flush_size_bytes: 31457280
    compaction_window: 1h0m0s
    max_compaction_objects: 6000000
    max_block_bytes: 107374182400
    block_retention: 336h0m0s
    compacted_block_retention: 1h0m0s
    retention_concurrency: 10
    iterator_buffer_size: 1000
    max_time_per_tenant: 5m0s
  override_ring_key: compactor
ingester:
  lifecycler:
    ring:
      kvstore:
        store: inmemory
        prefix: collectors/
        consul:
          host: localhost:8500
          acl_token: ""
          http_client_timeout: 20s
          consistent_reads: false
          watch_rate_limit: 1
          watch_burst_size: 1
        etcd:
          endpoints: []
          dial_timeout: 10s
          max_retries: 10
          tls_enabled: false
          tls_cert_path: ""
          tls_key_path: ""
          tls_ca_path: ""
          tls_server_name: ""
          tls_insecure_skip_verify: false
          username: ""
          password: ""
        multi:
          primary: ""
          secondary: ""
          mirror_enabled: false
          mirror_timeout: 2s
      heartbeat_timeout: 5m0s
      replication_factor: 1
      zone_awareness_enabled: false
      excluded_zones: ""
    num_tokens: 128
    heartbeat_period: 5s
    observe_period: 0s
    join_after: 0s
    min_ready_duration: 15s
    interface_names:
      - eth0
      - en0
    final_sleep: 30s
    tokens_file_path: ""
    availability_zone: ""
    unregister_on_shutdown: true
    readiness_check_ring_health: true
    address: 127.0.0.1
    port: 0
    id: hostname
  concurrent_flushes: 16
  flush_check_period: 10s
  flush_op_timeout: 5m0s
  trace_idle_period: 10s
  max_block_duration: 1h0m0s
  max_block_bytes: 1073741824
  complete_block_timeout: 15m0s
  override_ring_key: ring
storage:
  trace:
    pool:
      max_workers: 50
      queue_depth: 200
    wal:
      path: /tmp/tempo/wal
      completedfilepath: /tmp/tempo/wal/completed
      blocksfilepath: /tmp/tempo/wal/blocks
      encoding: snappy
      search_encoding: none
    block:
      index_downsample_bytes: 1048576
      index_page_size_bytes: 256000
      bloom_filter_false_positive: 0.01
      bloom_filter_shard_size_bytes: 102400
      encoding: zstd
      search_encoding: snappy
      search_page_size_bytes: 1048576
    search:
      chunk_size_bytes: 1000000
      prefetch_trace_count: 1000
    blocklist_poll: 5m0s
    blocklist_poll_concurrency: 50
    blocklist_poll_fallback: true
    blocklist_poll_tenant_index_builders: 2
    blocklist_poll_stale_tenant_index: 0s
    backend: local
    local:
      path: /tmp/tempo/traces
    gcs:
      bucket_name: ""
      chunk_buffer_size: 10485760
      endpoint: ""
      insecure: false
      hedge_requests_at: 0s
      hedge_requests_up_to: 2
    s3:
      bucket: ""
      endpoint: ""
      region: ""
      access_key: ""
      secret_key: ""
      insecure: false
      part_size: 0
      hedge_requests_at: 0s
      hedge_requests_up_to: 2
      signature_v2: false
      forcepathstyle: false
    azure:
      storage-account-name: ""
      storage-account-key: ""
      container-name: ""
      endpoint-suffix: blob.core.windows.net
      max-buffers: 4
      buffer-size: 3145728
      hedge-requests-at: 0s
      hedge-requests-up-to: 2
    cache: ""
    cache_min_compaction_level: 0
    cache_max_block_age: 0s
    background_cache:
      writeback_goroutines: 10
      writeback_buffer: 10000
    memcached: null
    redis: null
overrides:
  ingestion_rate_strategy: local
  ingestion_rate_limit_bytes: 15000000
  ingestion_burst_size_bytes: 20000000
  search_tags_allow_list: null
  max_traces_per_user: 10000
  max_global_traces_per_user: 0
  max_bytes_per_trace: 5000000
  max_search_bytes_per_trace: 5000
  block_retention: 0s
  max_bytes_per_tag_values_query: 5000000
  per_tenant_override_config: ""
  per_tenant_override_period: 10s
memberlist:
  node_name: ""
  randomize_node_name: true
  stream_timeout: 10s
  retransmit_factor: 2
  pull_push_interval: 30s
  gossip_interval: 1s
  gossip_nodes: 2
  gossip_to_dead_nodes_time: 30s
  dead_node_reclaim_time: 0s
  compression_enabled: false
  advertise_addr: ""
  advertise_port: 7946
  join_members: []
  min_join_backoff: 1s
  max_join_backoff: 1m0s
  max_join_retries: 10
  abort_if_cluster_join_fails: true
  rejoin_interval: 0s
  left_ingesters_timeout: 5m0s
  leave_timeout: 5s
  message_history_buffer_bytes: 0
  bind_addr: []
  bind_port: 7946
  packet_dial_timeout: 5s
  packet_write_timeout: 5s
  tls_enabled: false
  tls_cert_path: ""
  tls_key_path: ""
  tls_ca_path: ""
  tls_server_name: ""
  tls_insecure_skip_verify: false
```